import { useEffect } from "react";
import { useSpawnHandler } from "./actionHandler/spawnActionHandler";

// Conveyor Actions
export function useConveyorActions(point: ConveyorPointSchema) {
    const { handleSpawn } = useSpawnHandler();

    useEffect(() => {
        if (!point.action) return;

        const { actionType, material, delay, spawnInterval, spawnCount } = point.action;

        const handleAction = () => {
            switch (actionType) {
                case 'default':
                    console.log(`Default conveyor action at point ${point.uuid}`);
                    break;
                case 'spawn':
                    console.log(`Spawning material ${material} at point ${point.uuid}`);
                    handleSpawn(point);
                    break;
                case 'swap':
                    console.log(`Swapping to material ${material} at point ${point.uuid}`);
                    break;
                case 'delay':
                    console.log(`Delaying for ${delay}ms at point ${point.uuid}`);
                    break;
                case 'despawn':
                    console.log(`Despawning material at point ${point.uuid}`);
                    break;
            }
        };

        handleAction();

        return () => {
            // Cleanup if needed
        };
    }, [point]);
}